Bug 90274

Summary: Optimize Element::getAttributeNode() by replacing String with AtomicString
Product: WebKit Reporter: Kentaro Hara <haraken>
Component: DOMAssignee: Kentaro Hara <haraken>
Status: RESOLVED FIXED    
Severity: Normal CC: ap, cmarcelo, rniwa, webkit.review.bot
Priority: P2    
Version: 528+ (Nightly build)   
Hardware: Unspecified   
OS: Unspecified   
Bug Depends on:    
Bug Blocks: 90246    
Attachments:
Description Flags
Performance test
none
Patch none

Description Kentaro Hara 2012-06-29 05:16:19 PDT
Based on the observation described in this ChangeLog (http://trac.webkit.org/changeset/121439), the performance of Element::getAttributeNode() can be optimized by replacing String with AtomicString.
Comment 1 Kentaro Hara 2012-06-29 05:20:24 PDT
Created attachment 150147 [details]
Performance test
Comment 2 Kentaro Hara 2012-06-29 05:24:15 PDT
Created attachment 150148 [details]
Patch
Comment 3 Adam Barth 2012-07-27 01:05:04 PDT
Comment on attachment 150148 [details]
Patch

Based on further discussion in #webkit, my current understanding is that ap is ok with these patches.  I'm going to r+ them, but please give ap a chance to respond before landing.
Comment 4 Darin Adler 2012-07-27 07:08:36 PDT
Comment on attachment 150148 [details]
Patch

This is faster in some cases. But a case I’d expect this makes slower is when the passed-in attribute name is uppercase. This adds a lookup in the atomic string table of the not-yet-lowercased string.
Comment 5 Kentaro Hara 2012-08-07 18:21:59 PDT
Comment on attachment 150148 [details]
Patch

Looks like no strong objection, let me commit it.
Comment 6 WebKit Review Bot 2012-08-07 19:41:36 PDT
Comment on attachment 150148 [details]
Patch

Clearing flags on attachment: 150148

Committed r124972: <http://trac.webkit.org/changeset/124972>
Comment 7 WebKit Review Bot 2012-08-07 19:41:40 PDT
All reviewed patches have been landed.  Closing bug.